Subject: Re: [bug#55674] [PATCH 2/2] gnu: emacs-helpful: Update to 0.19.

From: Erik Šabič <[email-masked]>
Date: Fri, 27 May 2022 19:23:20 +0200

Okay, I figured it out. The test is indeed broken and
it's an easy fix. I will try sending a PR on github.

I have a lot to learn. I apologise for being a nuisance :)

Please tell me if there's anything else I can improve on.

Thank you!

here's a diff for the test:

 diff --git a/test/helpful-unit-test.el b/test/helpful-unit-test.el
index a07aa8e..1a61a6f 100644
--- a/test/helpful-unit-test.el
+++ b/test/helpful-unit-test.el
@@ -119,7 +119,7 @@ bar")))
   (should
    (equal
     (helpful--docstring #'test-foo-advised t)
-    "Docstring here too.")))
+    "Docstring here too.\n\nThis function has :around advice:
`ad-Advice-test-foo-advised'.")))

 (defun test-foo-no-docstring ()
   nil)

On Fri, May 27, 2022 at 3:48 PM Maxime Devos <[email-masked]> wrote:
>
> [Please keep [email-masked] in CC]
>
> Erik Šabič schreef op vr 27-05-2022 om 15:32 [+0200]:
> > Well it fails on a test defined like this:
> > (ert-deftest helpful--docstring ()
> >   "Basic docstring fetching."
> >   (should
> >    (equal
> >     (helpful--docstring #'test-foo t)
> >     "Docstring here.")))
> >
> > And fails like so:
> > ...............s...s..Test helpful--docstring-advice backtrace:
>
>
> >
> > Test helpful--docstring-advice condition:
> >
> >     (ert-test-failed
> >      ((should
> >        (equal
> >         (helpful--docstring ... t)
> >         "Docstring here too."))
> >       :form
> >       (equal "Docstring here too.\n\nThis function has :around
> > advice: `ad-Advice-test-foo-advised'." "Docstring here too.")
> >       :value nil :explanation
> >       (arrays-of-different-length 84 19 "Docstring here too.\n\nThis
> > function has :around advice: `ad-Advice-test-foo-advised'."
> > "Docstring here too." first-mismatch-at 19)))
> >
> > F............................................................s......
>
> Looks like a bug.
>
> > I don't know anything about emacs-ert. And I wasn't able to
> > figure out if it works for the upstream author.
> >
> > WDYT?
>
> I don't know if it fails for the upstream author, but I don't think
> that's relevant to Guix.  More relevant I think, is that this bug
> appears in Guix, so it can cause problems for Guix users, so some
> fixing might be necessary.
>
> I don't know much about Emacs though, so you might need to contact
> upstream about the bug.
>
> Greetings,
> Maxime.